
use tempdb
go

create table foo (name varchar(20), age int);
go
create table bar (name varchar(20), age int);
go

-- vanilla usage
INSERT INTO foo VALUES('Bob', 5), ('Mary', 6);
go

SELECT * FROM foo
go

-- no, subquery returned more than one value
INSERT INTO bar VALUES ((SELECT Name FROM foo), (SELECT Age FROM foo))
go
-- yes, scalar subqueries allowed in insert statement 
INSERT INTO bar VALUES ((SELECT TOP(1) Name FROM foo), (SELECT TOP(1) Age FROM foo))
go
-- no, not supported
go
INSERT INTO bar VALUES ((SELECT Name, Age FROM foo))
go

-- yes, row constructors are usable as data source
SELECT * FROM (VALUES('John Doe', 25, 5),('Jane Doe', 36, 6)) tab(name, age, score)
go

-- data types not specifiable
SELECT * FROM (VALUES('John Doe', 25, 5),('Jane Doe', 36, 6)) tab(name varchar(20), age int, score int)
go

-- no, syntax error
INSERT INTO foo
VALUES	(('John Doe', 25),
		('Peter Doe', 36),
		( SELECT Name, Age FROM bar));
go