
use Northwind
go

-- this is to enable filestream at an engine level
EXEC sp_filestream_configure 
    @enable_level = 3,
    @share_name = SQL05FS;
GO

-- change in CTP6
sp_configure 'show advanced options', 1
reconfigure
sp_configure 'filestream access level', '2'
reconfigure
go

ALTER DATABASE Northwind
 ADD FILEGROUP FileStreamGroup1 CONTAINS FILESTREAM
GO

ALTER DATABASE Northwind
    ADD FILE
      (
       NAME = Photos,
       FILENAME = 'C:\Files\Photos'
      )
   TO FILEGROUP FileStreamGroup1
GO


CREATE TABLE [dbo].[Employees2](
	[EmployeeID] [int] IDENTITY(1,1) NOT NULL,
	[LastName] [nvarchar](20) NOT NULL,
	[FirstName] [nvarchar](10) NOT NULL,
	[Title] [nvarchar](30) NULL,
	[Photo] [varbinary](max) FILESTREAM NULL,
	[ReportsTo] [int] NULL,
	[RowGuid] [UNIQUEIDENTIFIER]  NOT NULL  ROWGUIDCOL UNIQUE DEFAULT NEWID(),
 CONSTRAINT [PK_Employees2] PRIMARY KEY CLUSTERED 
(
	[EmployeeID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY] 

GO

ALTER TABLE [dbo].[Employees2]  WITH NOCHECK ADD  CONSTRAINT [FK_Employees2_Employees2] FOREIGN KEY([ReportsTo])
REFERENCES [dbo].[Employees2] ([EmployeeID])
GO

ALTER TABLE [dbo].[Employees2] CHECK CONSTRAINT [FK_Employees2_Employees2]
GO

SET IDENTITY_INSERT Employees2 ON
GO

INSERT INTO Employees2 (EmployeeID, LastName, FirstName, Title, Photo, ReportsTo)
SELECT EmployeeID, LastName, FirstName, Title, CONVERT(VARBINARY(MAX),Photo), ReportsTo
FROM Employees
GO

-- now add an attribute of the file as a persisted computed column
ALTER TABLE Employees2
  ADD Photo_Width AS SUBSTRING(Photo, 19,4) PERSISTED 
  
ALTER TABLE Employees2
  ADD Photo_Height AS SUBSTRING(Photo, 23,4) PERSISTED 
  
-- No index, though
CREATE INDEX IX_PhotoWidth ON Employees2(Photo_Width)
GO
