
-- 6.1.4 Point
declare @p geometry = 'POINT(1 2)';

-- A Point is a 0-dimensional geometric object 
-- and represents a single location in coordinate space. 
-- A Point has an x-coordinate value and a y-coordinate value.

select @p.STX as X, @p.STY as Y;

-- The boundary of a Point is the empty set.

select @p.STBoundary().ToString();
select @p.STBoundary().STIsEmpty(); -- true

-- 6.1.5 MultiPoint

/*
A MultiPoint is a 0-dimensional GeometryCollection. 
The elements of a MultiPoint are restricted to Points. 
The Points are not connected or ordered.
A MultiPoint is simple if no two Points in the MultiPoint are equal (have identical coordinate values).
*/
declare @mp1 geometry = 'MULTIPOINT(1 2, 2 3)';
declare @mp2 geometry = 'MULTIPOINT(1 2, 2 3, 1 2)';

select @mp1.STIsSimple(), @mp2.STIsSimple(); -- true, false

-- The boundary of a MultiPoint is the empty set.

select @mp1.STBoundary().ToString(), @mp2.STBoundary().ToString();