﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;


[Serializable]
[Microsoft.SqlServer.Server.SqlUserDefinedAggregate(Format.UserDefined,MaxByteSize=1000,IsNullIfEmpty=true)]
public struct CovarPop : IBinarySerialize
{
    decimal theanswer;
    decimal sumproduct;
    decimal sum1;
    decimal sum2;
    int count;

    public void Init()
    {
        theanswer = 0;
        sumproduct = 0;
        sum1 = 0;
        sum2 = 0;
        count = 0;
    }

    public void Accumulate([SqlFacet(Precision = 20, Scale = 10)] Nullable<decimal> Value1, [SqlFacet(Precision = 20, Scale = 10)] Nullable<decimal> Value2)
    {
        if (!Value1.HasValue)
            return;
        if (!Value2.HasValue)
            return;
        sum1 += Value1.Value;
        sum2 += Value2.Value;
        sumproduct += (Value1.Value * Value2.Value);
        count++;
    }

    public void Merge(CovarPop Group)
    {
        sum1 += Group.sum1;
        sum2 += Group.sum2;
        sumproduct += Group.sumproduct;
        count += Group.count;
    }

    [return: SqlFacet(Precision=20, Scale=10)]
    public Nullable<decimal> Terminate()
    {
        if (count == 0)
            return 0;

        theanswer = (sumproduct - sum2 * sum1 / count) / count;
        return theanswer;
    }

    public void Read(System.IO.BinaryReader r)
    {
        theanswer = r.ReadDecimal();
        sumproduct = r.ReadDecimal();
        sum1 = r.ReadDecimal();
        sum2 = r.ReadDecimal();
        count = r.ReadInt32();
    }

    public void Write(System.IO.BinaryWriter w)
    {
        // the values will always be non-null
        w.Write(theanswer);
        w.Write(sumproduct);
        w.Write(sum1);
        w.Write(sum2);
        w.Write(count);
    }
    

}
