
use AdventureWorks
go


-- SQLCLR code to list ancestors
-- fix path or point project to c:\temp
CREATE ASSEMBLY HierarchyId_Operations 
FROM 'C:\temp\HierarchyProj\bin\Debug\HierarchyProj.dll'
GO

CREATE FUNCTION ListAncestors (@node hierarchyid)
RETURNS TABLE (node hierarchyid)
AS
EXTERNAL NAME HierarchyId_Operations.HierarchyId_Operations.ListAncestors
GO

DECLARE @h hierarchyid
SELECT @h = OrgNode 
FROM HumanResources.EmployeeOrg  
WHERE EmployeeID = 291             -- Kevin

SELECT EmployeeID, EmpName, OrgNode.ToString() AS LogicalNode
FROM HumanResources.EmployeeOrg AS ED
JOIN ListAncestors(@h) AS A 
   ON ED.OrgNode = A.Node
GO

CREATE FUNCTION CommonAncestor (@node1 hierarchyid, @node2 hierarchyid)
RETURNS hierarchyid
AS
EXTERNAL NAME HierarchyId_Operations.HierarchyId_Operations.CommonAncestor
GO

DECLARE @h1 hierarchyid, @h2 hierarchyid

SELECT @h1 = OrgNode 
FROM  HumanResources.EmployeeOrg 
WHERE EmployeeID = 291             -- Kevin

SELECT @h2 = OrgNode 
FROM HumanResources.EmployeeOrg  
WHERE EmployeeID = 272             -- Mary

SELECT OrgNode.ToString() AS LogicalNode, EmployeeID, EmpName 
FROM HumanResources.EmployeeOrg  
WHERE OrgNode = dbo.CommonAncestor(@h1, @h2) ;