
declare @myDoc xml
declare @OrderID int
declare @OrderDate date
declare @OrderTime time
declare @OrderDateTime datetimeoffset

set @myDoc = '<Root>
<OrderDescription OrderID="1" OrderDate="1999-12-20" OrderTime="13:40:58.47786" OrderDateTime="1999-12-20 13:40:58.123 -5:00">
<Features>	
  <Warranty>1 year parts and labor</Warranty>
  <Maintenance>3 year parts and labor extended maintenance is available</Maintenance>
</Features>
</OrderDescription>
</Root>'

set @OrderID =  @myDoc.value('(/Root/OrderDescription/@OrderID)[1]', 'int' )
set @OrderDate =  @myDoc.value('(/Root/OrderDescription/@OrderDate)[1]', 'date' ) 
set @OrderTime =  @myDoc.value('(/Root/OrderDescription/@OrderTime)[1]', 'time' ) 
set @OrderDateTime =  @myDoc.value('(/Root/OrderDescription/@OrderDateTime)[1]', 'DATETIMEOFFSET' ) 

select @OrderID as [OrderID],
       @OrderDate as [OrderDate],
       @OrderTime as [OrderDateTime],
       @OrderDateTime as [OrderDateTimeWithOffset]

/*
DATE	xsd:date
TIME	xsd:time
DATETIMEOFFSET	xsd:datetime
DATETIME2	xsd:datetime
*/

USE tempdb
GO

DROP TABLE T
DROP TABLE T1
DROP TABLE T2
DROP PROCEDURE foo
GO

CREATE TABLE T (xmlcol XML)
INSERT INTO T VALUES(
'<a><b date="1996-12-16"/></a>')
GO
Create table T1 ( dt date, tm time, dtz DATETIMEOFFSET)
Insert into T1 values ('1996-12-16', '12:30:47.7867', '1996-12-16 12:30:47.7867 -5:00')
go

CREATE procedure foo(@d date) as
select * from T where xmlcol.exist('/a/b[@date = sql:variable("@d")]') = 1
GO

declare @t time
declare @dtz DATETIMEOFFSET
select * from T where xmlcol.exist('/a/b[@time = sql:variable("@t")]') = 1
select * from T where xmlcol.exist('/a/b[@datetime = sql:variable("@dtz")]') = 1

Create table T2 ( dtz date )
select * 
from T1, T2 T
where T.xmlcol.exist('/a/b[@date = sql:column("T1.dtz")]') = 1

Select dt from T1 FOR XML Auto
Select tm from T1 FOR XML Auto
Select dtz from T1 FOR XML Auto

DROP TABLE T1
GO

/* OpenXML */

Create table T1 ( dt date, tm time, dtz DATETIMEOFFSET)

DECLARE @docHandle int
declare @xmlDocument nvarchar(max) -- or xml type
set @xmlDocument = N'<ROOT>
<T1 dt="2000-08-25" tm="12:30:47.7867" dtz="2000-08-25T05:22:36.33345 -5:00"/>
</ROOT>'

EXEC sp_xml_preparedocument @docHandle OUTPUT, @xmlDocument

-- Use OPENXML to provide rowset consisting of customer data.
INSERT T1
SELECT * 
FROM OPENXML(@docHandle, N'/ROOT/T1') 
  WITH T1

-- Using OPENXML in a SELECT statement.
SELECT * FROM OPENXML(@docHandle, N'/ROOT/T1') WITH (dt date '../@dt', tm time, dtz DATETIMEOFFSET)

EXEC sp_xml_removedocument @docHandle 

